/* /////////////////////////////////////////////////////////////////////////////
 * File:        acestl/string_access.hpp
 *
 * Purpose:     Helper functions for ACE classes.
 *
 * Created:     2nd December 2004
 * Updated:     17th July 2005
 *
 * Home:        http://stlsoft.org/
 *
 * Copyright (c) 2004-2005, Matthew Wilson and Synesis Software
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * - Neither the name(s) of Matthew Wilson and Synesis Software nor the names of
 *   any contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * ////////////////////////////////////////////////////////////////////////// */


/// \file acestl/string_access.hpp
///
/// Helper functions for ACE classes.

#ifndef ACESTL_INCL_ACESTL_HPP_STRING_ACCESS
#define ACESTL_INCL_ACESTL_HPP_STRING_ACCESS

#ifndef STLSOFT_DOCUMENTATION_SKIP_SECTION
# define ACESTL_VER_ACESTL_HPP_STRING_ACCESS_MAJOR      1
# define ACESTL_VER_ACESTL_HPP_STRING_ACCESS_MINOR      0
# define ACESTL_VER_ACESTL_HPP_STRING_ACCESS_REVISION   1
# define ACESTL_VER_ACESTL_HPP_STRING_ACCESS_EDIT       4
#endif /* !STLSOFT_DOCUMENTATION_SKIP_SECTION */

/* ////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#ifndef ACESTL_INCL_ACESTL_HPP_ACESTL
# include <acestl/acestl.hpp>
#endif /* !ACESTL_INCL_ACESTL_HPP_ACESTL */
#ifndef ACESTL_INCL_ACESTL_HPP_INET_ADDR_STRING_ACCESS
# include <acestl/inet_addr_string_access.hpp>
#endif /* !ACESTL_INCL_ACESTL_HPP_INET_ADDR_STRING_ACCESS */
#ifndef ACESTL_INCL_ACESTL_HPP_TIME_STRING_ACCESS
# include <acestl/time_string_access.hpp>
#endif /* !ACESTL_INCL_ACESTL_HPP_TIME_STRING_ACCESS */
#ifndef ACESTL_INCL_ACESTL_HPP_STRING_STRING_ACCESS
# include <acestl/string_string_access.hpp>
#endif /* !ACESTL_INCL_ACESTL_HPP_STRING_STRING_ACCESS */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* !ACESTL_INCL_ACESTL_HPP_STRING_ACCESS */

/* ////////////////////////////////////////////////////////////////////////// */
