/* /////////////////////////////////////////////////////////////////////////////
 * File:        stlsoft/associative_adaptor_sequences.hpp
 *
 * Purpose:     Associative container adaptor sequences.
 *
 * Created:     28th January 2005
 * Updated:     22nd December 2005
 *
 * Home:        http://stlsoft.org/
 *
 * Copyright (c) 2005, Matthew Wilson and Synesis Software
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * - Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * - Neither the name(s) of Matthew Wilson and Synesis Software nor the names of
 *   any contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * ////////////////////////////////////////////////////////////////////////// */


/// \file stlsoft/associative_adaptor_sequences.hpp
///
/// Associative container adaptor sequences

#ifndef STLSOFT_INCL_STLSOFT_HPP_ASSOCIATIVE_ADAPTOR_SEQUENCES
#define STLSOFT_INCL_STLSOFT_HPP_ASSOCIATIVE_ADAPTOR_SEQUENCES

#ifndef STLSOFT_DOCUMENTATION_SKIP_SECTION
# define STLSOFT_VER_STLSOFT_HPP_ASSOCIATIVE_ADAPTOR_SEQUENCES_MAJOR    1
# define STLSOFT_VER_STLSOFT_HPP_ASSOCIATIVE_ADAPTOR_SEQUENCES_MINOR    1
# define STLSOFT_VER_STLSOFT_HPP_ASSOCIATIVE_ADAPTOR_SEQUENCES_REVISION 1
# define STLSOFT_VER_STLSOFT_HPP_ASSOCIATIVE_ADAPTOR_SEQUENCES_EDIT     7
#endif /* !STLSOFT_DOCUMENTATION_SKIP_SECTION */

/* /////////////////////////////////////////////////////////////////////////////
 * Compatibility
 */

/*
[Incompatibilies-start]
STLSOFT_COMPILER_IS_WATCOM:
[Incompatibilies-end]
 */

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#ifndef STLSOFT_INCL_STLSOFT_H_STLSOFT
# include <stlsoft/stlsoft.h>
#endif /* !STLSOFT_INCL_STLSOFT_H_STLSOFT */
#ifndef STLSOFT_INCL_STLSOFT_HPP_ASSOCIATIVE_KEY_SEQUENCE
# include <stlsoft/associative_key_sequence.hpp>
#endif /* !STLSOFT_INCL_STLSOFT_HPP_ASSOCIATIVE_KEY_SEQUENCE */
#ifndef STLSOFT_INCL_STLSOFT_HPP_ASSOCIATIVE_VALUE_SEQUENCE
# include <stlsoft/associative_value_sequence.hpp>
#endif /* !STLSOFT_INCL_STLSOFT_HPP_ASSOCIATIVE_VALUE_SEQUENCE */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* !STLSOFT_INCL_STLSOFT_HPP_ASSOCIATIVE_ADAPTOR_SEQUENCES */

/* ////////////////////////////////////////////////////////////////////////// */
